%global e_sitedir  %{_datadir}/emacs/site-lisp
%global xe_sitedir %{_datadir}/xemacs/site-lisp
%global sitepdir   %{_datadir}/xemacs/site-packages
%global confsample_dir %{_datadir}/config-sample

Summary: Maxima Symbolic Computation Program
Name: maxima

%global momorel 1
Version: 5.12.0
%global realver %{version}%{?rcver:rc%{rcver}}
Release: %{?rcver:0.%{rcver}.}%{momorel}m%{?dist}
License: GPL
Group: Applications/Engineering
URL: http://maxima.sourceforge.net/

### include local configuration
%{?include_specopt}
# default lisp may be one of clisp,cmucl,gcl
%{?!default_lisp: %global default_lisp      clisp}
%{?!build_gcl:    %global build_gcl         0}
%{?!build_clisp:  %global build_clisp       1}
%ifarch %{ix86}
%{?!build_cmucl:  %global build_cmucl       1}
%else
%{?!build_cmucl:  %global build_cmucl       0}
%endif

%NoSource 0 http://dl.sourceforge.net/sourceforge/%{name}/%{name}-%{realver}.tar.gz 0cc3c006ffc94e4f922161b6e6b98f11
%NoSource 1 http://maxima.sourceforge.net/docs/maximabook/maximabook-19-Sept-2004.pdf 9faa5a513de43b5e7384216a8783f620
Source2: maxima-modes.el
Patch0: maxima-5.9.0-infodir.patch
Patch1: maxima-5.9.2-emaxima.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: texinfo, tetex-latex, tetex-dvipsk
BuildRequires: desktop-file-utils
BuildRequires: readline-devel >= 5.0
%if %{build_clisp}
BuildRequires: clisp
%endif
%if %{build_gcl}
BuildRequires: gcl >= 2.5.3-5m
%endif
%if %{build_cmucl}
BuildRequires: cmucl
%endif
Requires: maxima_exec = %{version}-%{release}, gnuplot

%description
Maxima is a full symbolic computation program.  It is full featured
doing symbolic manipulation of polynomials, matrices, rational
functions, integration, Todd-coxeter, graphing, bigfloats.  It has a
symbolic debugger source level debugger for maxima code.  Maxima is
based on the original Macsyma developed at MIT in the 1970's.  It is
quite reliable, and has good garbage collection, and no memory leaks.
It comes with hundreds of self tests.
#'

%package xmaxima
Summary: Tcl/Tk interface to Maxima
Group: Applications/Engineering
Requires: tk
Requires: %{name} = %{version}-%{release}
Provides: xmaxima

%description xmaxima
Tcl/Tk interface to Maxima.

%if %{build_gcl}
%package exec_gcl
Summary: Maxima compiled with GCL
Group: Applications/Engineering
Requires: %{name} = %{version}-%{release}
Provides: maxima_exec

%description exec_gcl
Maxima compiled with Gnu Common Lisp.
%endif

%if %{build_clisp}
%package exec_clisp
Summary: Maxima compiled with clisp
Group: Applications/Engineering
Requires: %{name} = %{version}-%{release}
Requires: clisp
Provides: maxima_exec

%description exec_clisp
Maxima compiled with clisp.
%endif

%if %{build_cmucl}
%package exec_cmucl
Summary: Maxima compiled with CMUCL
Group: Applications/Engineering
Requires: %{name} = %{version}-%{release}
Requires: cmucl
Provides: maxima_exec

%description exec_cmucl
Maxima compiled with CMUCL.
%endif

%package -n elisp-emaxima
Summary: Common files for EMaxima
Group: Applications/Engineering
Requires: %{name} = %{version}-%{release}
Requires: tetex

%description -n elisp-emaxima
Common files for EMaxima, Emacsen interface to Maxima

%package -n emaxima-emacs
Summary: EMaxima, Emacs interface to Maxima
Group: Applications/Engineering
Requires: emacs
Requires: %{name} = %{version}-%{release}
Requires: elisp-emaxima = %{version}-%{release}
Provides: emaxima

%description -n emaxima-emacs
EMaxima, Emacs interface to Maxima

%package -n emaxima-xemacs
Summary: EMaxima, XEmacs interface to Maxima
Group: Applications/Engineering
Requires: xemacs
Requires: %{name} = %{version}-%{release}
Requires: elisp-emaxima = %{version}-%{release}
Provides: emaxima

%description -n emaxima-xemacs
EMaxima, XEmacs interface to Maxima

%prep
%setup -q -n %{name}-%{realver}
cp %{SOURCE1} .
#%patch1 -p1
%__cp interfaces/emacs/emaxima/emaxima.sty doc/maximabook

%build
CFLAGS=`echo %{optflags} | sed -e 's/-ffast-math//g'`
CXXFLAGS=`echo %{optflags} | sed -e 's/-ffast-math//g'`
%if %{build_clisp}
CLISP="--enable-clisp"
%else
CLISP="--disable-clisp"
%endif
%if %{build_gcl}
GCL="--enable-gcl"
%else
GCL="--disable-gcl"
%endif
%if %{build_cmucl}
CMUCL="--enable-cmucl --with-cmucl=lisp --with-cmucl-runtime=/usr/lib/cmucl/bin/lisp"
%else
CMUCL="--disable-cmucl"
%endif


%configure \
    --with-default-lisp=%{default_lisp} \
    $CLISP $GCL $CMUCL

%__make
%__make check

#(
#  cd doc/maximabook
#  %__make
#)
(
  cd doc/intromax
  latex intromax.ltx
  dvips intromax.dvi
  pdflatex intromax.ltx
)

%install
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%makeinstall

## copy info file for maxima.
%__mkdir_p %{buildroot}%{_datadir}/%{name}/%{realver}/info
%__install -m 0644 %{buildroot}%{_infodir}/maxima.info* \
  %{buildroot}%{_datadir}/%{name}/%{realver}/info

## emaxima
# LaTeX style
install -d %{buildroot}%{_datadir}/texmf/tex/latex/emaxima
cp -alf %{buildroot}%{_datadir}/%{name}/%{version}/emacs/*.sty \
	%{buildroot}%{_datadir}/texmf/tex/latex/emaxima/
# emacs
install -d %{buildroot}%{e_sitedir}/maxima
cp -alf %{buildroot}%{_datadir}/%{name}/%{version}/emacs/*.el \
	%{buildroot}%{_datadir}/%{name}/%{version}/emacs/*.lisp \
	%{buildroot}%{_datadir}/emacs/site-lisp/maxima/

# xemacs
install -d %{buildroot}%{sitepdir}/lisp/maxima
cp -alf %{buildroot}%{_datadir}/%{name}/%{version}/emacs/*.el \
	%{buildroot}%{_datadir}/%{name}/%{version}/emacs/*.lisp \
	%{buildroot}%{sitepdir}/lisp/maxima/
# config sample
mkdir -p %{buildroot}%{confsample_dir}/emaxima
install -m644 -p  %{SOURCE2} %{buildroot}%{confsample_dir}/emaxima

# desktop
%__mkdir_p %{buildroot}%{_datadir}/applications
%__cat > xmaxima.desktop <<EOF
[Desktop Entry]
Name=XMaxima
GenericName=Symbolic Computation Program
Comment=Symbolic Computation Program
Exec=xmaxima
Terminal=false
Type=Application
Icon=xmaxima.png
EOF

# install desktop file
desktop-file-install --vendor= --delete-original \
  --dir %{buildroot}%{_datadir}/applications \
  --add-category Engineering \
  --add-category Science \
  --add-category Math \
  xmaxima.desktop

# link icon
%__mkdir_p %{buildroot}%{_datadir}/pixmaps
%__ln_s ../%{name}/%{realver}/xmaxima/maxima-icon.png \
  %{buildroot}%{_datadir}/pixmaps/xmaxima.png

%__rm -f %{buildroot}%{_infodir}/dir

%clean
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%post
/sbin/install-info %{_infodir}/%{name}.info.* %{_infodir}/dir

%postun
/sbin/install-info --delete %{_infodir}/%{name}.info.* %{_infodir}/dir

%files
%defattr(-,root,root)
%doc AUTHORS COPYING INSTALL README README.lisps README.rpms
# %%doc doc/maximabook/maxima.ps doc/maximabook/maxima.pdf
%doc maximabook-19-Sept-2004.pdf
%doc doc/intromax/intromax.ps doc/intromax/intromax.pdf
%{_bindir}/%{name}
%{_bindir}/rmaxima
%dir %{_libexecdir}/%{name}
%{_libexecdir}/%{name}/%{realver}
%{_infodir}/*.info*
%{_infodir}/maxima-index.lisp.bz2
%{_mandir}/man1/*.1*
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/%{realver}
%{_datadir}/%{name}/%{realver}/demo
%{_datadir}/%{name}/%{realver}/doc
%{_datadir}/%{name}/%{realver}/info
#%{_datadir}/%{name}/%{realver}/msgs
%{_datadir}/%{name}/%{realver}/share
%{_datadir}/%{name}/%{realver}/src
%{_datadir}/%{name}/%{realver}/tests

%files xmaxima
%defattr(-,root,root)
%{_bindir}/xmaxima
%{_datadir}/applications/xmaxima.desktop
%{_datadir}/%{name}/%{realver}/xmaxima
%{_datadir}/pixmaps/xmaxima.png

%if %{build_gcl}
%files exec_gcl
%defattr(-,root,root)
%{_libdir}/%{name}/%{realver}/binary-gcl
%endif

%if %{build_clisp}
%files exec_clisp
%defattr(-,root,root)
%{_libdir}/%{name}/%{realver}/binary-clisp
%endif

%if %{build_cmucl}
%files exec_cmucl
%defattr(-,root,root)
%{_libdir}/%{name}/%{realver}/binary-cmucl
%endif

%files -n elisp-emaxima
# emaxima common
%{_datadir}/%{name}/%{realver}/emacs
%{confsample_dir}/emaxima
%{_datadir}/texmf/tex/latex/emaxima

%files -n emaxima-emacs
%defattr(-,root,root)
%{e_sitedir}/*

%files -n emaxima-xemacs
%defattr(-,root,root)
%{sitepdir}/lisp/maxima

%changelog
* Fri Jun 01 2007 Masayuki SANO <nosanosa@momonga-linux.org>
- (5.12.0-1m)
- update to 5.12.0

* Sat Jan 20 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (5.11.0-1m)
- update to 5.11.0

* Tue Oct 03 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (5.10.0-1m)
- update to 5.10.0

* Sat Sep 16 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (5.9.3-4m)
- remove category Application

* Fri Jul  7 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (5.9.3-3m)
- rebuild against readline-5.0

* Sat Jun 10 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (5.9.3-2m)
- delete duplicated dir

* Wed Apr 26 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (5.9.3-1m)
- update to 5.9.3
- made emacsen interface subpackages (elisp-emaxima, emaxima-emacs, emaxima-xemacs)
- import maxima-5.9.2-emaxima.patch, maxima-mode.el from Fedora Extra (5.9.3-1.fc6)

* Wed Jan 18 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (5.9.2-1m)
- version 5.9.2

* Thu Feb 17 2005 mutecat <mutecat@momonga-linux.org>
- (5.9.1-3m)
- arrange ppc without cmucl

* Thu Jan 13 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (5.9.1-2m)
- add Education to Categories of xmaxima.desktop for KDE

* Sun Oct 31 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (5.9.1-1m)
- version 5.9.1 has been released.
- use %%build_gcl etc. to control whether to build with specific lisps
- - set %%build_gcl to 0 because gcl_binary fails to build...Please fix!
- not make docs and download it from the web site
- - latex procedure fails because build requires some *.sty which are missing

* Tue May  4 2004 Toru Hoshina <t@momonga-linux.org>
- (5.9.0-8m)
- rebuild against ncurses 5.3.

* Tue Mar 23 2004 Toru Hoshina <t@momonga-linux.org>
- (5.9.0-7m)
- revised spec for enabling rpm 4.2.

* Tue Dec 30 2003 Kenta MURATA <muraken2@nifty.com>
- (5.9.0-6m)
- copy info for ? command.

* Mon Dec 29 2003 Kenta MURATA <muraken2@nifty.com>
- (5.9.0-5m)
- %%NoSource.
- --enable-gcl and --with-default-lisp=gcl.
- includes some documents.

* Mon Dec 29 2003 Kenta MURATA <muraken2@nifty.com>
- (5.9.0-4m)
- --enable-gcl
- %%NoSource.

* Thu Mar  6 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (5.9.0-3m)
- fix URL
- add and tmp comment out loop BuildRequires: maxima-xmaxima

* Fri Feb 14 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (5.9.0-2m)
- [Momonga-devel.ja:01389] thanks.

* Tue Feb 11 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (5.9.0-1m)
  update to 5.9.0

* Thu Nov 14 2002 OZAWA -Crouton- Sakuro <crouton@momonga-linux.org>
- (5.9.0-0.3.1m)
- initial import to Momonga.

* Sun Sep  8 2002 James Amundson <amundson@fnal.gov> 
- Initial build.
